/*
 * $Id: about.c,v 1.1 2003/11/14 10:03:37 alexanto Exp $
 *
 * $Doctor Gauge (C) 2000-2003 A. Antonini, All rights reserved $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: Main dialog implementation $
 *
 * $Log: about.c,v $
 * Revision 1.1  2003/11/14 10:03:37  alexanto
 * Initial revision
 *
 */

#include <windows.h>
#include <shellapi.h>
#include "utils.h"
#include "resource.h"
#include "globals.h"


/*
 * window procedure routine
 */
int WINAPI AboutDialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	char membuf[80];
	char winbuf[80];
	char outbuf[80];
	char *ptr;
	MEMORYSTATUS ms;
    OSVERSIONINFO os;

	ver_info_t vi;

	switch (uMsg)
	{
	case WM_INITDIALOG:
		GetFileVersion(&vi);						// get exefile information

		ms.dwLength=sizeof(ms);
		os.dwOSVersionInfoSize=sizeof(os);
		GlobalMemoryStatus(&ms);					// get avail memory
		GetVersionEx(&os);							// get OS version

		wsprintf(membuf,"Version %s",vi.szFileVersion);

		for (ptr=membuf; *ptr; ptr++)				// replace , with periods
			if (*ptr==',')							// (more ptretty to display)
				*ptr='.';

		// format product name, file version and copyright
		SetWindowText(GetDlgItem(hWnd,IDC_PRODUCT_NAME),
			vi.szProductName);
		SetWindowText(GetDlgItem(hWnd,IDC_FILE_VERSION),
			membuf);
		SetWindowText(GetDlgItem(hWnd,IDC_LEGAL_COPYRIGHT),
			vi.szLegalCopyright);


		switch (os.dwPlatformId)					// see what OS we are under
		{
		case VER_PLATFORM_WIN32_WINDOWS:			// windows v9.x
        	wsprintf(winbuf,"Windows v9.x ver. %d.%d (build %d)",
            	os.dwMajorVersion, os.dwMinorVersion, 
				os.dwBuildNumber & 0xffff);
			break;
		case VER_PLATFORM_WIN32_NT:					// NT, w2k or XP
        	wsprintf(winbuf,"Windows NT ver. %d.%d (build %d)",
            	os.dwMajorVersion, os.dwMinorVersion, 
				os.dwBuildNumber & 0xffff);
			break;
		default:									// win32s !!! :-)))
        	wsprintf(winbuf,"MS Windows ver. %d.%d (build %d)",
            	os.dwMajorVersion, os.dwMinorVersion, 
				os.dwBuildNumber & 0xffff);
			break;
		}

		SetWindowText(								// format all display labels
			GetDlgItem(hWnd,IDC_WIN_VERSION),
			winbuf);
		str_insert_commas(outbuf,ms.dwAvailPhys/1024);
		wsprintf(membuf,"Available memory to Windows: %s Kb (%d%%)",
			outbuf,100-ms.dwMemoryLoad);
		SetWindowText(GetDlgItem(hWnd,IDC_WIN_MEMORY),membuf);
		CenterWindow(hWnd);
		return FALSE;

	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDC_URL:								// go to my url
			ShellExecute(hWnd,"open","http://www.cpinf.net",
				NULL,NULL,SW_SHOW);
		case IDOK:
			EndDialog(hWnd,IDOK);					// bye bye
			return TRUE;
		case IDCANCEL:
			EndDialog(hWnd,IDCANCEL);
			return TRUE;
		}
		break;
	}

	return FALSE;
}

/*
 * execute about box
 */
int RunAboutBox(HWND hWnd)
{
	return DialogBoxParam(GlobalInstance,
		MAKEINTRESOURCE(IDD_ABOUT_DIALOG),hWnd,
		AboutDialogProc,0);
}
