/*
 * $Id: drgauge.c,v 1.3 2003/11/14 10:39:24 alexanto Exp Alessandro $
 *
 * $Doctor Gauge (C) 2000-2003 A. Antonini, All rights reserved $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: Main application$
 *
 * $Log: drgauge.c,v $
 * Revision 1.3  2003/11/14 10:39:24  alexanto
 * Modified routines for finding previous
 * instances of application
 *
 * Revision 1.2  2003/11/14 10:18:38  alexanto
 * +Id+Log
 *
 * Revision 1.1  2003/11/14 10:03:37  alexanto
 * Initial revision
 *
 */

#include <windows.h>
#include <commctrl.h>
#include "globals.h"
#include "main.h"
#include "regscan.h"
#include "utils.h"

static const char RcsID[] = "$Id: drgauge.c,v 1.3 2003/11/14 10:39:24 alexanto Exp Alessandro $";

typedef struct	// structure to find previous instance of window
{

	char *pszText;
	int found;
} enum_windows_data;


/*
 * enumerate routine to see if drgauge is already running
 */
BOOL CALLBACK EnumWindowsProc(HWND hwnd,LPARAM lParam)
{
	enum_windows_data *ptr = (enum_windows_data *)lParam;
	char window_text[128];
	GetWindowText(hwnd,window_text,sizeof(window_text));
	if (strstr(window_text,ptr->pszText) || 
		strstr(window_text,"Multiple simulators installed"))	// we found it ?
	{
		SetForegroundWindow(hwnd);
		ptr->found=1;
		return FALSE;
	}
	return TRUE;							// else continue looping
}

/*
 * app entry-point routine
 */
int APIENTRY WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine, 
					 int nCmdShow)
{
	int i,code;
	ver_info_t vi;
	enum_windows_data window_data;
	InitCommonControls();					// make sure comctl32 is loaded properly

	GetFileVersion(&vi);					// get file version
	window_data.found=0;
	window_data.pszText=vi.szProductName;
	EnumWindows(EnumWindowsProc, 
		(LPARAM)&window_data);				// see if we have a running copy of drgauge
	if (window_data.found)				
		return 0;							// we have, so quit 

	GetAppPath(szHelpFile);					// form path to help file
	VerifySlash(szHelpFile);
	lstrcat(szHelpFile,szHelp);
	GlobalInstance=hInstance;				// store application instance


	code = TestFlightSimulator(NULL);		// see if we have multiple FS installed
	if (code==-1)
		return 0;
	
	
	i = RunMainDialog(code);				// run application
	return i;
}
