/*
 * $Id: multipfs.c,v 1.1 2003/11/14 10:03:37 alexanto Exp $
 *
 * $Doctor Gauge (C) 2000-2003 A. Antonini, All rights reserved $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: multiple fs dialog$
 *
 * $Log: multipfs.c,v $
 * Revision 1.1  2003/11/14 10:03:37  alexanto
 * Initial revision
 *
 */
#include <windows.h>
#include <htmlhelp.h>
#include "multipfs.h"
#include "utils.h"
#include "resource.h"
#include "globals.h"
#include "regscan.h"


/*
 * window procedure routine
 */
int WINAPI MultipleFsDialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	int i;
	WORD wNotifyCode;
	//HELPINFO *lpHelpInfo;
	switch (uMsg)
	{
	case WM_INITDIALOG:
		CenterWindow(hWnd);
		SendMessage(GetDlgItem(hWnd,IDC_FS2002), BM_SETCHECK, BST_CHECKED,0);
		return FALSE;

	case WM_HELP:
		HtmlHelp(hWnd, szHelpFile, HH_HELP_CONTEXT, IDD_MULTIPLE_FS); 
		return TRUE;

	case WM_COMMAND:
		if ((wNotifyCode = HIWORD(wParam))==BN_DOUBLECLICKED)
		{
			switch(LOWORD(wParam))
			{
			case IDC_FS2002:
				EndDialog(hWnd,RESULT_FS2K2);
				return TRUE;
			case IDC_FS2004:
				EndDialog(hWnd,RESULT_FS2K4);
				return TRUE;
			}
		}
		else
		{
			switch(LOWORD(wParam))
			{
			case IDHELP:
				HtmlHelp(hWnd, szHelpFile, HH_HELP_CONTEXT, IDD_MULTIPLE_FS); 
				return TRUE;
			case IDOK:
				if ( BST_CHECKED == (i = SendMessage(GetDlgItem(hWnd,IDC_FS2002), 
					BM_GETCHECK, 0,0)))
					EndDialog(hWnd,RESULT_FS2K2);
				else
					EndDialog(hWnd,RESULT_FS2K4);
				return TRUE;
			case IDCANCEL:
				EndDialog(hWnd,IDCANCEL);
				return TRUE;
			}
		}
		break;
	}
	return FALSE;
}


/*
 * execute main dialog routine
 */
int RunMultipleFsDialog(HWND hWnd)
{
	return DialogBox(GlobalInstance,MAKEINTRESOURCE(IDD_MULTIPLE_FS),
		hWnd,(DLGPROC)MultipleFsDialogProc);

}
