/*
 * $Id: regscan.c,v 1.1 2003/11/14 10:03:37 alexanto Exp $
 *
 * $Doctor Gauge (C) 2000-2003 A. Antonini, All rights reserved $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Desc: Flight simulator registry scanner $
 *
 * $Log: regscan.c,v $
 * Revision 1.1  2003/11/14 10:03:37  alexanto
 * Initial revision
 *
 */
#include <windows.h>
#include "regscan.h"
#include "globals.h"
#include "multipfs.h"

typedef struct _tagFsRegistryData
{
	int nFlags;				// fs flags
	int nSims;				// number of simulator installed
	char szFs2k2Path[1024];	
	char szFs2k4Path[1024];	
} fs_regdata_t;


static void FsRegistryScan(fs_regdata_t *ptr)
{
	HKEY key;
    char pathbuf[2048];
    DWORD dwType, dwLength=sizeof(pathbuf);
	nFsFlags=0;

	ZeroMemory(ptr,sizeof(fs_regdata_t));

	if (ERROR_SUCCESS == RegOpenKeyExA(HKEY_LOCAL_MACHINE, // test for fs2002
		szFs2k2Key, 0, KEY_READ, &key))
	{
		if (ERROR_SUCCESS ==  RegQueryValueEx(key, "EXE Path", NULL,
        	&dwType, (BYTE *)pathbuf, &dwLength))
		{
            lstrcpy(ptr->szFs2k2Path,pathbuf);
            ptr->nFlags = ptr->nFlags | BITFS2K2;
			ptr->nSims++;
		}
		RegCloseKey(key);
	}

	dwLength=sizeof(pathbuf);
	if (ERROR_SUCCESS == RegOpenKeyExA(HKEY_LOCAL_MACHINE, // test for fs2004
		szFs2k4Key, 0, KEY_READ, &key))
	{
		if (ERROR_SUCCESS ==  RegQueryValueEx(key, "EXE Path", NULL,
        	&dwType, (BYTE *)pathbuf, &dwLength))
		{
            lstrcpy(ptr->szFs2k4Path,pathbuf);
            ptr->nFlags = ptr->nFlags | BITFS2K4;
			ptr->nSims++;
		}
		RegCloseKey(key);
	}
}


int TestFlightSimulator(HWND hWnd)
{
	fs_regdata_t ptr;
	int dwRes;
	FsRegistryScan(&ptr);
	switch (ptr.nSims)
	{
	case 0:
		MessageBox(hWnd,"Flight Simulator is not installed on this machine","Error",
			MB_OK | MB_ICONERROR);
		return -1;
	case 1:
		if (ptr.nFlags & BITFS2K2)
		{
			lstrcpy(szFsPath,ptr.szFs2k2Path);
			return RESULT_FS2K2;
		}
		else
		{
			lstrcpy(szFsPath,ptr.szFs2k4Path);
			return RESULT_FS2K4;
		}
	default:
		dwRes = RunMultipleFsDialog(hWnd);
		if (dwRes==IDCANCEL)
			return -1;
		else if (dwRes==RESULT_FS2K2)
			lstrcpy(szFsPath,ptr.szFs2k2Path);
		else
			lstrcpy(szFsPath,ptr.szFs2k4Path);
		return dwRes;
	}
}
