/*
 * $Id: shfile.h,v 1.1 2003/11/14 10:06:40 alexanto Exp Alessandro $
 */
#define SH_SRC_FILE 0
#define SH_DEST_FILE 1



typedef struct
{
	//max no. char in source string
	long lMaxSrcCount;
	
	//max no. char in dest string
	long lMaxDestCount;
	
	//current no. char in source string
	long lCurSrcCount;
	
	//current no. char in dest string
	long lCurDestCount;
	
	//structure for shell call
	SHFILEOPSTRUCT lpFileOp;
	
	//pointer to start of source string
	char *pTo;
	
	//pointer to start of dest string
	char *pFrom;
	
	//current pointer in source string
	char *pSrc;
	
	//current pointer in dest string
	char *pDest;	
	
	//title to be used on dialog
	char *pTitle;
} shell_op_t;


void ShellFileOpInit(HWND hWnd, shell_op_t *);
void ShellFileOpDestroy(shell_op_t *);
long ShellFileOpDeleteFiles(shell_op_t *);
long ShellFileOpMoveFiles(shell_op_t *);
long ShellFileOpCopyFiles(shell_op_t *);
long ShellFileOpRenameFiles(shell_op_t *);
void ShellFileOpClearFiles(int, shell_op_t *);
void ShellFileOpAddFile(int, const char *, shell_op_t *);
void ShellFileOpSetMaxCount(int, long, shell_op_t *);
void ShellFileOpSetTitle(const char *, shell_op_t *);
void ShellFileOpSetTitle(const char *, shell_op_t *);

